=== debian/changelog ===
megaglest (3.6.0.2-2ubuntu2) precise; urgency=low

  * README.txt confirms that this is for x86 architectures only (as forced
    by the x86 assembly in the FPU routines). Changed arch field to match.

 -- Ben Collins <bcollins@ubuntu.com>  Thu, 19 Jan 2012 18:28:01 +0000

megaglest (3.6.0.2-2ubuntu1) precise; urgency=low

  * Don't build with -DMINIUPNPC_VERSION_PRE1_6=true as we have 1.6 in
    the archive.

 -- Andreas Moog <amoog@ubuntu.com>  Thu, 12 Jan 2012 19:56:35 +0100

megaglest (3.6.0.2-2) unstable; urgency=low

  * Team upload.
  * Fix the upstream check for networking so it matches kFreeBSD
  * Disable the wx-config --prefix=/usr/local since that is the
    wrong path on Debian GNU/kFreeBSD
  * Drop the SSE flags since they are redundant on amd64, cause
    Illegal instruction errors on i386 and cause FBTS on other arches
  * Add more little-endian architectures

 -- Paul Wise <pabs@debian.org>  Fri, 23 Dec 2011 14:36:25 +0800

megaglest (3.6.0.2-1) unstable; urgency=low

  [ Alexander Reichle-Schmehl ]
  * Remove myself from uploaders due to time constraints

  [ Ansgar Burchardt ]
  * Remove myself from Uploaders.

  [ Mark Vejvoda ]
  * updated for 3.6.0 release
  * renamed from glest to megaglest and changed build system to cmake

  [ Paul Wise ]
  * Lots of cleanup and improvements

 -- Mark Vejvoda <mark_vejvoda@hotmail.com>  Tue, 20 Dec 2011 15:46:18 +0800

glest (3.2.2-2) unstable; urgency=low

  [ Paul Wise ]
  * debian/rules:
     - Drop use of dh_desktop since it no longer does anything and
       desktop-file-utils 0.15-2 has a trigger (see #525133).

  [ Siegfried-Angel Gevatter Pujals ]
  * debian/control:
     - Add lpia to the Architecture list.
     - Add "${misc:Depends}" to Depends.
  * debian/patches/series, debian/patches/missing-cstdio-include:
     - Fix a FTBFS which happens with new GCC versions; thanks to
       Steven Susbauer (LP: #376591).

  [ Eddy Petrișor ]
  * enable tutorials by symlinking to the real tutorial directory
    (Closes: #528181)

  [ Alexander Reichle-Schmehl ]
  * Add debian/README.source

 -- Alexander Reichle-Schmehl <tolimar@debian.org>  Fri, 12 Feb 2010 15:10:38 +0100

glest (3.2.2-1) unstable; urgency=low

  * New Upstream release
   - Repackage the tarball from .zip to .tar.gz.
  * Updated my name in control file
  * adopt depends on glest-data
   - Removed the lintian override

 -- Alexander Reichle-Schmehl <tolimar@debian.org>  Sun, 05 Apr 2009 20:21:04 +0200

glest (3.2.1-1) unstable; urgency=low

  [ Siegfried-Angel Gevatter Pujals ]
  * New upstream version.
     - Repackage the tarball from .zip to .tar.gz.
     - The default resultion is now 640x480 (Closes: #450770).
  * debian/control:
     - Change my entry in the Uploaders field.
     - Add a Build-Depends on liblua5.1-dev, autoconf and automake.
     - Bump Standards-Version to 3.8.0.
  * debian/glest.install:
     - Adjust the origin path.
  * debian/glest.desktop:
     - Fix a typo in the Catalan description.
  * debian/patches/nomapeditor, debian/patches/do-not-link-unneeded-libs:
     - Update them to apply against the new source.
  * debian/patches/series, debian/patches/gcc-4.3-fixes:
     - Remove gcc-4.3-fixes, it has been adopted upstream.
  * debian/rules:
     - Update it to work with the changed directory structure.
  * debian/dirs:
     - Remove some unnecessary lines (we still need bin/games because the only
       file there is installed by debian/rules without using dh_install).
  * debian/copyright:
     - Update the copyright information and change the formatting of the file.
     - Change the download location to SourceForge.
     - Update the copyright to match the directory structure changes.
  * debian/docs:
     - Upstream's README files have no interesting content; remove it.
  * debian/patches/fix-glest-ini:
     - Change "english.lng" to just "english".
  * debian/glest.sh:
     - If there is an existing glest.ini file, change "<langname.lng>" to
       just "<langname>". Also, if the selected language isn't available
       anymore change it back to "english", in order to avoid the game refusing
       to start.
     - Replace the configuration file (glest.ini) with a new one if it is too
       old (setting are not preserved).
     - Create directory ~/.glest/screens for the screenshots (Closes: #505919).
     - Do not create a "docs" symlink amymore (LP: #226584).
     - Move configuration files from ~/.glest to ~/.config/glest.
  * debian/glest.6:
     - Update the manpage for Glest 3 (Closes: #505917).
  * debian/menu:
     - Change formatting to make the file more readable.
  * debian/glest.desktop:
     - Add a Spanish translation of the Comment.

  [ Gonéri Le Bouder ]
  * French translation for the .desktop file.

 -- Siegfried-Angel Gevatter Pujals <rainct@ubuntu.com>  Fri, 13 Mar 2009 16:26:52 +0100

glest (3.1.2-1) unstable; urgency=low

  [ Siegfried-Angel Gevatter Pujals (RainCT)]
  * Fix debian/watch to work despite the constantly changing filenames.
  * Update the description:
     - Mention multiplayer support.
     - Do not longer speak about two factions, as there will be more
       somewhen soon.

  [ Gonéri Le Bouder ]
  * Add armel in arch list (Closes: #476943)

  [ Ansgar Burchardt ]
  * New upstream release (Closes: #468810)
  * Updates to wrapper script:
     - Install servers.ini (Closes: #467247)
     - Do not create symlink to configuration.xml which does not exist.
  * New patches:
     - gcc-4.3-fixes: Add missing includes for gcc-4.3
     - do-not-link-unneeded-libs: Do not link against libogg, libvorbis
  * Add missing .TH in manpage
  * Update libxerces build-depend to libxerces-c2-dev
  * Don't set CFLAGS, CXXFLAGS (now set by dpkg-buildpackage)
  * debian/copyright: Update, point to GPL-2

 -- Ansgar Burchardt <ansgar@43-1.org>  Sun, 04 May 2008 17:01:38 +0200

glest (3.1.0-1) unstable; urgency=low

  [ Barry deFreese ]
  * Add watch file

  [ Jon Dowland ]

